﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;

namespace CSharpSA_SDKExample
{
    public class SA_CollObjectName
    {
        public String Coll = @"A";
        public String objectName = @"";
        public SA_Type saType = new SA_Type();

        public SA_CollObjectName()
        {
            // typeName = typeNames.ElementAt(TypeIdx.eAny);
        }


        public SA_CollObjectName(String c, String objName, TypeIdx nameIdx)
        {
            Coll = c;
            objectName = objName;
            saType.SetType(nameIdx);
        }

        public String GetCollObjNameType()
        {
            String c_ObjName = Coll + "::" + objectName + "::" + saType.GetTypeName();
            return c_ObjName;
        }
        public void SetCollObjectName_Type(String c, String objName, TypeIdx t)
        {
            Coll = c;
            objectName = objName;
            saType.typeIdx = t;
        }

        public bool SetCollObjectNameType(string con)
        {
            char[] delimiters = { ':', ',' };
            string[] words = con.Split(delimiters);
            if (words.Count() >= 4)
            {
                Coll = words[0];
                objectName = words[2];
                saType.SetType(words[4]);
                return true;
            }
            return false;
        }

        public bool SetCollObjectName(string con)
        {
            char[] delimiters = { ':', ',' };
            string[] words = con.Split(delimiters);
            if (words.Count() >= 2)
            {
                Coll = words[0];
                objectName = words[2];
                return true;
            }
            return false;
        }


        public String GetCollObjName()
        {
            String c_ObjName = Coll + "::" + objectName;
            return c_ObjName;
        }

        public override string ToString()
        {
            return GetCollObjName();
        }

        public String GetCollName()
        {
            return Coll;
        }
        public String GetObjName()
        {
            return objectName;
        }
        public String GetObjType()
        {
            return saType.GetTypeName();
        }
    }
}
