﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CSharpSA_SDKExample
{
    public class SA_CollObjectNameList
    {

        public List<SA_CollObjectName> collObjNameRefList = new List<SA_CollObjectName>();

        public SA_CollObjectNameList()
        {
            // typeName = typeNames.ElementAt(TypeIdx.eAny);
        }


        public SA_CollObjectNameList(String c, String objName, TypeIdx nameIdx)
        {
            SA_CollObjectName con = new SA_CollObjectName(c, objName, nameIdx);
            collObjNameRefList.Add(con);
        }

        public String GetCollObjNameType(int idx)
        {
            string type = "";
            if (collObjNameRefList.Count <= idx && idx >= 0)
            {
                type = collObjNameRefList[idx].saType.GetTypeName();
            }
            return type;
        }

        public String GetCollObjNameIdx(int idx)
        {
            String c_ObjName = "";
            if (collObjNameRefList.Count <= idx && idx >= 0)
            {
                c_ObjName = collObjNameRefList[idx].GetCollObjNameType();
            }
            return c_ObjName;
        }

        public SA_CollObjectName GetCollObjName(int idx)
        {
            SA_CollObjectName c_ObjName = new SA_CollObjectName();
            if (collObjNameRefList.Count <= idx && idx >= 0)
            {
                c_ObjName = collObjNameRefList[idx];
            }
            return c_ObjName;
        }

        public bool RemoveCollObjectNameIdx(int idx)
        {
            bool ret = false;
            if (collObjNameRefList.Count <= idx && idx >= 0)
            {
                collObjNameRefList.RemoveAt(idx);
                ret = true;
            }
            return ret;

        }

        public void GetStringList(ref List<string> sl)
        {
            foreach (SA_CollObjectName con in collObjNameRefList)
            {
                sl.Add(con.GetCollObjName());
            }
        }
    }
}
