﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CSharpSA_SDKExample
{
    public class SA_PointNameRefList
    {
        public List<SA_TargetName> ptNameRefList = new List<SA_TargetName>();

        public SA_PointNameRefList()
        {
        }

        public String GetPointNameAtIdx(int idx)
        {
            String c_PtName = "";
            if (ptNameRefList.Count <= idx && idx >= 0)
            {
                c_PtName = ptNameRefList[idx].GetTargetName();
            }
            return c_PtName;
        }

        public SA_TargetName GetCollGrpPtName(int idx)
        {
            SA_TargetName c_PtName = new SA_TargetName();
            if (ptNameRefList.Count <= idx && idx >= 0)
            {
                c_PtName = ptNameRefList[idx];
            }
            return c_PtName;
        }

        public bool RemovePtNameIdx(int idx)
        {
            bool ret = false;
            if (ptNameRefList.Count <= idx && idx >= 0)
            {
                ptNameRefList.RemoveAt(idx);
                ret = true;
            }
            return ret;

        }

        public void MakePointNameList(ref List<string> ptNameList)
        {
            foreach (SA_TargetName tn in ptNameRefList)
            {
                ptNameList.Add(tn.GetCollGrpTargetName());
            }
        }

        public void GetTargetNameStringList(ref List<string> sl)
        {
            foreach (SA_TargetName con in ptNameRefList)
            {
                sl.Add(con.GetTargetName());
            }
        }

        public void GetCollGrpPointNameStringList(ref List<string> sl)
        {
            foreach (SA_TargetName con in ptNameRefList)
            {
                sl.Add(con.GetCollGrpTargetName());
            }
        }
    }
}
