﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CSharpSA_SDKExample
{
    public class SA_TargetName
    {
        public String Coll = @"";
        public String grpName = @"";
        public String targetName = @"";

        public DateTime timestamp;

        public SA_TargetName()
        {
            // typeName = typeNames.ElementAt(TypeIdx.eAny);
            timestamp = DateTime.Now;
        }

        public SA_TargetName(string coll_grp_t)
        {
            char[] delimiters = { ':', ',' };
            string[] words = coll_grp_t.Split(delimiters);
            if (words.Count() >= 4)
            {
                Coll = words[0];
                grpName = words[2];
                targetName = words[4];
            }
        }

        public override string ToString()
        {
            return GetCollGrpTargetName();
        }

        public SA_TargetName(String c, String ptgrpName, String targName)
        {
            Coll = c;
            grpName = ptgrpName;
            targetName = targName;

            timestamp = DateTime.Now;
        }

        public String GetTargetName()
        {
            return targetName;
        }
        public String GetCollName()
        {
            return Coll;
        }

        public String GetCollGrpName()
        {
            return Coll + "::" + grpName;
        }

        public String GetCollGrpTargetName()
        {
            return Coll + "::" + grpName + "::" + targetName;
        }

        public String GetGrpName()
        {
            return grpName;
        }
    }
}
